#ifndef GENERATEUR_RECYCLEUR_H
#define GENERATEUR_RECYCLEUR_H

#include "Intervalle.h"
#include "Sequence.h"
#include "SingletonContextFwd.h"
#include "Incopiable.h"
#include <deque>
#include <limits>
#include <algorithm>

template <class T>
   class GenerateurRecycleur
      : Sequence<T>, Incopiable
   {
   public:
      using value_type = typename Sequence<T>::value_type;
   private:
      std::deque<value_type> recyclable;
      GenerateurRecycleur()
         : Sequence<T>(T{}, std::numeric_limits<T>::max())
      {
      }
      bool contient(value_type val) const
      {
         using namespace std;
         return find(begin(recyclable), end(recyclable), val) != end(recyclable);
      }
      friend struct SingletonWrapper<GenerateurRecycleur<T>>;
   public:
      value_type prochain()
      {
         if (recyclable.empty()) return prochaine_valeur();
         auto val = recyclable.front();
         recyclable.pop_front();
         return val;
      }
      void remettre(value_type val)
      {
         if (contient(val)) throw ValeurIncoherente{};
         recyclable.push_back(val);
      }
   };

#endif
