#ifndef GENERATEURSEQUENTIEL_H
#define GENERATEURSEQUENTIEL_H

#include "Intervalle.h"
#include "Sequence.h"
#include "SingletonContextFwd.h"
#include "Incopiable.h"

//
// Contrat de T:
// - Intervalle<T> est lgal
// - Sequence<T> est lgal
//
// Contrat de Interv:
// - se comporte comme un Intervalle<T>
//
// Le truc: spcifier Interv permet de paramtrer des singletons sur
// un type T donn mais sur des intervalles distincts
//
template <class T, class Interv = Intervalle<T>>
   class GenerateurSequentiel
      : Sequence<T>, Incopiable
   {
   public:
      using value_type = typename Sequence<T>::value_type;
   private:
      GenerateurSequentiel(const Interv &bornes = {})
         : Sequence<T>(bornes.minval, bornes.maxval)
      {
      }
      friend struct SingletonWrapper<GenerateurSequentiel<T, Interv>>;
   public:
      value_type prochain()
      {
         auto valeur = curval();
         prochaine_valeur();
         return valeur;
      }
   };

#endif
