#include "GenerateurStochastique.h"
#include <random>
#include <type_traits>
using namespace std;

GenerateurStochastique::GenerateurStochastique()
   : prng{ random_device {}() }
{
}

template <class T>
   struct distribution_type_trait
   {
      using type = conditional_t<is_integral<T>::value, uniform_int_distribution<T>, uniform_real_distribution<T>>;
   };

// bornes inclusives
auto GenerateurStochastique::prochain (const Intervalle<value_type> &bornes) const -> value_type
{
   distribution_type_trait<value_type>::type de{ bornes.minval, bornes.maxval };
   return de(prng);
}

