#ifndef SEQUENCE_H
#define SEQUENCE_H

#include "Intervalle.h"

//
// Contrat de T:
// - constructeur paramtrique
// - oprateur <
// - oprateur++ prfix
// - oprateur d'affectation
//
template <class T>
   class Sequence
   {
   public:
      using value_type = T;
   private:
      Intervalle<value_type> intvl;
      value_type cur;
   public:
      Sequence(value_type minval, value_type maxval)
         : intvl{ minval, maxval }, cur{ minval }
      {
      }
      value_type curval() const
         { return cur; }
      value_type prochaine_valeur()
      {
         const auto valeur = curval();
         cur = valeur == intvl.maxval() ? intvl.minval() : cur + 1;
         return valeur;
      }
   };

#endif
