#ifndef SINGLETON_CONTEXT_FWD_H
#define SINGLETON_CONTEXT_FWD_H

template <class>
   class NonRespectSingleton {};

template <class T>
   struct SingletonWrapper
   {
      static int nb_inst;
      using type = T;
   private:
      type singleton;
   public:
      SingletonWrapper()
      {
         if (nb_inst++) throw NonRespectSingleton<T>{};
      }
      type& get()
         { return singleton; }
   };
template <class T>
   int SingletonWrapper<T>::nb_inst = {};

#endif
