#ifndef SINGLETON_DEFINITION_H
#define SINGLETON_DEFINITION_H

#include "GenerateurStochastique.h"
#include "GenerateurSequentiel.h"
#include "GenerateurUnique.h"
#include "GenerateurRecycleur.h"
#include "type_list.h"
#include "SingletonContext.h"


struct IntervalleUsuel
   : Intervalle<int>
{
   IntervalleUsuel()
      : Intervalle<int>(0)
   {
   }
};

using GenerateurUsuel = GenerateurSequentiel<int, IntervalleUsuel>;

//
// Le plus prs du dbut de la liste est construit en dernier. On va
// donc du type dpendant du moins grand nombre de types  celui
// dpendant du plus grand nombre de types.
//
using les_singletons = type_list <GenerateurUnique, GenerateurUsuel, GenerateurRecycleur<int>, GenerateurStochastique>;
using singletons = SingletonContext<les_singletons>;

#endif 
